"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var email_log_1 = require("./email-log");
var SendgridWrapper = (function () {
    function SendgridWrapper(sendgridApiKey) {
        this.sendgridApiKey = sendgridApiKey;
        this.sendgridMail = require('@sendgrid/mail');
        this.sendgridMail.setApiKey(sendgridApiKey);
    }
    SendgridWrapper.prototype.send = function (toEmail, fromEmail, subject, type, html) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var sgMsg = {
                to: toEmail,
                from: fromEmail,
                subject: subject,
                html: html
            };
            _this.sendgridMail.send(sgMsg).then(function () {
                resolve(new email_log_1.EmailLog(sgMsg.to, sgMsg.from, type));
            }).catch(function (error) {
                reject(new Error('could not send email to "' + sgMsg.to + '"' + error));
            });
        });
    };
    return SendgridWrapper;
}());
exports.SendgridWrapper = SendgridWrapper;
