"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require('fs');
var Handlebars = require('handlebars');
var TemplateCompiler = (function () {
    function TemplateCompiler() {
        this.compiledPages = { confirm: {} };
        this.compiledPages["confirm-email"] = this.compileTemplate('confirm-email');
        this.compiledPages["deadline"] = this.compileTemplate('deadline');
        this.compiledPages['generic'] = this.compileTemplate('generic');
        this.compiledPages['hello'] = this.compileTemplate('hello');
        this.compiledPages['password-reset'] = this.compileTemplate('password-reset');
        this.compiledPages['receipt'] = this.compileTemplate('receipt');
        this.compiledPages['rented'] = this.compileTemplate('rented');
    }
    TemplateCompiler.prototype.getHtml = function (emailTemplateConfig, emailTemplateInput) {
        var combinedData = {
            emailTemplateInput: emailTemplateInput,
            emailTemplateConfig: emailTemplateConfig
        };
        return this.compiledPages[emailTemplateInput.emailType](combinedData);
    };
    TemplateCompiler.prototype.compileTemplate = function (name) {
        var rawHtml = fs.readFileSync(__dirname + '/../../templates/' + name + '.html', 'utf8');
        return Handlebars.compile(rawHtml);
    };
    return TemplateCompiler;
}());
exports.TemplateCompiler = TemplateCompiler;
